<template>
  <a-drawer
    :width="width"
    :visible="visible"
    :mask-closable="false"
    unmount-on-close
    @ok="handleConfirm"
    @cancel="handleCancel"
  >
    <template #title> {{ locale.title }} </template>
    <div class="settingContainer">
      <div class="header">
        <a-input-search
          v-model="searchWords"
          :placeholder="locale.searchPlaceHolder"
          allow-clear
          @input="handleSearchInput"
          @search="handleSearchInput"
          @clear="handleSearchInput"
        />
        <a-button class="header-right" type="primary" @click="resetDefault">{{
          locale.reset
        }}</a-button>
      </div>
      <div ref="contentRef" class="content">
        <a-scrollbar style="height: calc(100vh - 180px); overflow: auto">
          <div v-if="leftRenderColumnsList.length" data-fixed="left">
            <div class="title">{{ locale.fixedLeft }}</div>
            <a-table
              :selected-keys="selectedKeys"
              :pagination="false"
              :columns="TABLE_COLUMNS"
              :bordered="false"
              :row-selection="ROW_SELECTION"
              :data="leftRenderColumnsList"
              :sticky-header="true"
              row-key="dataIndex"
              :draggable="{ type: 'handle', width: 40 }"
              @select="handleSelect"
              @row-click="handleRowClick"
              @change="handleLeftChange"
            >
              <template #title="{ record }">
                <column-item
                  is="left"
                  :record="record"
                  :hide-action="enableVirtual"
                  :locale="locale"
                  @goto-direction="gotoDirection"
                />
              </template>
            </a-table>
          </div>
          <div v-if="rightRenderColumnsList.length" data-fixed="right">
            <div class="title">{{ locale.fixedRight }}</div>
            <a-table
              :selected-keys="selectedKeys"
              :pagination="false"
              :columns="TABLE_COLUMNS"
              :bordered="false"
              :row-selection="ROW_SELECTION"
              :data="rightRenderColumnsList"
              :sticky-header="true"
              row-key="dataIndex"
              :draggable="{ type: 'handle', width: 40 }"
              @select="handleSelect"
              @row-click="handleRowClick"
              @change="handleRightChange"
            >
              <template #title="{ record }">
                <column-item
                  is="right"
                  :record="record"
                  :hide-action="enableVirtual"
                  :locale="locale"
                  @goto-direction="gotoDirection"
                />
              </template>
            </a-table>
          </div>
          <div data-fixed="center">
            <div
              v-if="
                leftRenderColumnsList.length || rightRenderColumnsList.length
              "
              class="title"
            >
              {{ locale.noFixed }}
            </div>
            <a-table
              :selected-keys="selectedKeys"
              :pagination="false"
              :columns="TABLE_COLUMNS"
              :bordered="false"
              :row-selection="ROW_SELECTION"
              :data="renderColumnsList"
              :sticky-header="true"
              row-key="dataIndex"
              :draggable="{ type: 'handle', width: 40 }"
              @select="handleSelect"
              @row-click="handleRowClick"
              @change="handleCenterChange"
            >
              <template #title="{ record }">
                <column-item
                  is="center"
                  :record="record"
                  :hide-action="enableVirtual"
                  :locale="locale"
                  @goto-direction="gotoDirection"
                />
              </template>
            </a-table>
          </div>
        </a-scrollbar>
      </div>
    </div>
  </a-drawer>
</template>

<script lang="ts" setup>
import { TableInstance } from '@arco-design/web-vue'
import { Ref, onMounted, ref, watch } from 'vue'
import {
  ITableColumnData,
  useSearch,
  useSelect,
  useFixedColumns,
  calculateShowColumns,
  useInit,
  useDrag,
  ILocale,
  calcConfig
} from './help'
import ColumnItem from './item.vue'
import { zhCN, en, zhTW, ru } from './lang'
import { useLocale } from '@arco-vue-x/utils'

const contentRef = ref<HTMLDivElement>()

const { locale } = useLocale<ILocale>({
  zhCN,
  en,
  zhTW,
  ru
})
const props = withDefaults(
  defineProps<{
    // 列配置是否展示
    visible: boolean;
    // 父table初始化列
    initColmuns: ITableColumnData[];
    // 父table当前列配置
    showColumns?: ITableColumnData[];
    // 父table实例
    tableRef?: TableInstance;
    // 抽屉宽度
    width?: number;
    // 是否自动初始化
    autoInit?: boolean;
  }>(),
  {
    initColmuns: () => [],
    width: 360,
    autoInit: true
  }
)

const emit = defineEmits([
  // 更新父table展示的列配置
  'update:showColumns',
  // 父table是否可见
  'update:visible',
  // 发送最新配置
  'changeConfig',
  'reset'
])

const {
  // 用户自定义的列配置中间变量
  columns,
  // 把列分为左侧固定、右侧固定、不固定三组
  initData: initGroup,
  // 列分组
  columnsGroup,
  // 左固定列
  leftRenderColumnsList,
  // 不固定列
  renderColumnsList,
  // 右固定列
  rightRenderColumnsList,
  // 是否开启了虚拟滚动
  enableVirtual,
  // 列选择器
  ROW_SELECTION,
  // 当前表格列（非父元素）
  TABLE_COLUMNS
} = useInit(
  () => props.initColmuns,
  () => props.tableRef,
  () => locale.value as ILocale
)

watch([() => props.visible], () => {
  if (props.visible) {
    columns.value = props.initColmuns
  }
})

// 搜索逻辑
const {
  // 搜索关键词
  searchWords,
  // 当搜索时
  handleSearchInput
} = useSearch(
  columnsGroup,
  leftRenderColumnsList,
  renderColumnsList,
  rightRenderColumnsList
)

// 选择逻辑
const {
  // 当前选择了哪些列展示
  selectedKeys,
  // 从现有列配置中读取哪些列正在展示
  initSelect,
  // 当选择时
  handleSelect,
  // 当点击行时
  handleRowClick
} = useSelect(
  contentRef as Ref<HTMLDivElement>,
  leftRenderColumnsList,
  renderColumnsList,
  rightRenderColumnsList,
  columns.value,
  () => props.visible,
  locale.value?.mustShowInfo as string
)

// 处理拖拽
const {
  // 左侧固定列发生拖拽影响排序时
  handleLeftChange,
  // 不固定列发生拖拽影响排序时
  handleCenterChange,
  // 右侧固定列发生拖拽影响排序时
  handleRightChange
} = useDrag(leftRenderColumnsList, renderColumnsList, rightRenderColumnsList)

// 处理固定逻辑
const {
  // 固定列发生变化时
  gotoDirection
} = useFixedColumns(
  renderColumnsList,
  leftRenderColumnsList,
  rightRenderColumnsList
)

// 影响父元素的showColumns
const sendData = () => {
  const allColumns = leftRenderColumnsList.value.concat(
    renderColumnsList.value,
    rightRenderColumnsList.value
  )
  const newColumns = allColumns.map((item) => ({
    ...item,
    hidden: !selectedKeys.value.includes(item.dataIndex as string)
  }))
  columns.value = newColumns
  emit('update:showColumns', calculateShowColumns(newColumns))
  emit('changeConfig', calcConfig(newColumns))
}

// 初始化
const initData = () => {
  initSelect()
  initGroup()
  sendData()
}

// 恢复默认
const resetDefault = () => {
  emit('reset')
}

// 确认
const handleConfirm = () => {
  emit('update:visible', false)
  sendData()
}

// 取消
const handleCancel = () => {
  emit('update:visible', false)
  initData()
}
onMounted(() => {
  props.autoInit && initData()
})

defineExpose({
  initData
})
</script>

<style scoped lang="less">
.settingContainer {
  height: 100%;
  display: flex;
  flex-direction: column;
  .header {
    margin-bottom: 10px;
    display: flex;
    align-items: center;
    justify-content: space-between;

    &-right {
      margin-left: 10px;
    }
  }
  .content {
    flex: auto;
    height: 0;
    :deep(.arco-table-td) {
      border-bottom: none;
      cursor: pointer;
    }
    :deep(.arco-table-td.arco-table-drag-handle) {
      cursor: move;
    }
  }
}
</style>
